// Kozak's Romaji Converter v1.1 by N'sLAB Copyright (C) 2006 by Nobumichi Kozawa
public class RomaConv
{
    private String [] a3r, a2r, a1r;
    private String [] a3h, a2h, a1h;
    private String [] a3k, a2k, a1k;
    private String [] a3n, a2n, a1n;
    private String [] i3r, i2r, i1r;
    private String [] i3h, i2h, i1h;
    private String [] i3k, i2k, i1k;
    private String [] i3n, i2n, i1n;
    private String [] u4r, u3r, u2r, u1r;
    private String [] u4h, u3h, u2h, u1h;
    private String [] u4k, u3k, u2k, u1k;
    private String [] u4n, u3n, u2n, u1n;
    private String [] e3r, e2r, e1r;
    private String [] e3h, e2h, e1h;
    private String [] e3k, e2k, e1k;
    private String [] e3n, e2n, e1n;
    private String [] o3r, o2r, o1r;
    private String [] o3h, o2h, o1h;
    private String [] o3k, o2k, o1k;
    private String [] o3n, o2n, o1n;


    public RomaConv()
    {
        a3r = new String[28];
        a3h = new String[28];
        a3k = new String[28];
        a3n = new String[28];
        a3r[0] = "kya"; a3h[0] = "きゃ"; a3k[0] = "キャ"; a3n[0] = "ｷｬ";
        a3r[1] = "kwa"; a3h[1] = "くぁ"; a3k[1] = "クァ"; a3n[1] = "ｸｧ";
        a3r[2] = "sya"; a3h[2] = "しゃ"; a3k[2] = "シャ"; a3n[2] = "ｼｬ";
        a3r[3] = "sha"; a3h[3] = "しゃ"; a3k[3] = "シャ"; a3n[3] = "ｼｬ";
        a3r[4] = "tya"; a3h[4] = "ちゃ"; a3k[4] = "チャ"; a3n[4] = "ﾁｬ";
        a3r[5] = "cya"; a3h[5] = "ちゃ"; a3k[5] = "チャ"; a3n[5] = "ﾁｬ";
        a3r[6] = "cha"; a3h[6] = "ちゃ"; a3k[6] = "チャ"; a3n[6] = "ﾁｬ";
        a3r[7] = "tsa"; a3h[7] = "つぁ"; a3k[7] = "ツァ"; a3n[7] = "ﾂｧ";
        a3r[8] = "tha"; a3h[8] = "てゃ"; a3k[8] = "テャ"; a3n[8] = "ﾃｬ";
        a3r[9] = "nya"; a3h[9] = "にゃ"; a3k[9] = "ニャ"; a3n[9] = "ﾆｬ";
        a3r[10] = "hya"; a3h[10] = "ひゃ"; a3k[10] = "ヒャ"; a3n[10] = "ﾋｬ";
        a3r[11] = "fya"; a3h[11] = "ふゃ"; a3k[11] = "フャ"; a3n[11] = "ﾌｬ";
        a3r[12] = "mya"; a3h[12] = "みゃ"; a3k[12] = "ミャ"; a3n[12] = "ﾐｬ";
        a3r[13] = "lya"; a3h[13] = "ゃ"; a3k[13] = "ャ"; a3n[13] = "ｬ";
        a3r[14] = "xya"; a3h[14] = "ゃ"; a3k[14] = "ャ"; a3n[14] = "ｬ";
        a3r[15] = "rya"; a3h[15] = "りゃ"; a3k[15] = "リャ"; a3n[15] = "ﾘｬ";
        a3r[16] = "lwa"; a3h[16] = "ゎ"; a3k[16] = "ヮ"; a3n[16] = "";
        a3r[17] = "xwa"; a3h[17] = "ゎ"; a3k[17] = "ヮ"; a3n[17] = "";
        a3r[18] = "gya"; a3h[18] = "ぎゃ"; a3k[18] = "ギャ"; a3n[18] = "ｷﾞｬ";
        a3r[19] = "gwa"; a3h[19] = "ぐぁ"; a3k[19] = "グァ"; a3n[19] = "ｸﾞｧ";
        a3r[20] = "jya"; a3h[20] = "じゃ"; a3k[20] = "ジャ"; a3n[20] = "ｼﾞｬ";
        a3r[21] = "zya"; a3h[21] = "じゃ"; a3k[21] = "ジャ"; a3n[21] = "ｼﾞｬ";
        a3r[22] = "dya"; a3h[22] = "ぢゃ"; a3k[22] = "ヂャ"; a3n[22] = "ﾁﾞｬ";
        a3r[23] = "dha"; a3h[23] = "でゃ"; a3k[23] = "デャ"; a3n[23] = "ﾃﾞｬ";
        a3r[24] = "bya"; a3h[24] = "びゃ"; a3k[24] = "ビャ"; a3n[24] = "ﾋﾞｬ";
        a3r[25] = "pya"; a3h[25] = "ぴゃ"; a3k[25] = "ピャ"; a3n[25] = "ﾋﾟｬ";
        a3r[26] = "lka"; a3h[26] = "ヵ"; a3k[26] = "ヵ"; a3n[26] = "";
        a3r[27] = "xka"; a3h[27] = "ヵ"; a3k[27] = "ヵ"; a3n[27] = "";

        a2r = new String[19];
        a2h = new String[19];
        a2k = new String[19];
        a2n = new String[19];
        a2r[0] = "la"; a2h[0] = "ぁ"; a2k[0] = "ァ"; a2n[0] = "ｧ";
        a2r[1] = "xa"; a2h[1] = "ぁ"; a2k[1] = "ァ"; a2n[1] = "ｧ";
        a2r[2] = "ka"; a2h[2] = "か"; a2k[2] = "カ"; a2n[2] = "ｶ";
        a2r[3] = "sa"; a2h[3] = "さ"; a2k[3] = "サ"; a2n[3] = "ｻ";
        a2r[4] = "ta"; a2h[4] = "た"; a2k[4] = "タ"; a2n[4] = "ﾀ";
        a2r[5] = "na"; a2h[5] = "な"; a2k[5] = "ナ"; a2n[5] = "ﾅ";
        a2r[6] = "ha"; a2h[6] = "は"; a2k[6] = "ハ"; a2n[6] = "ﾊ";
        a2r[7] = "fa"; a2h[7] = "ふぁ"; a2k[7] = "ファ"; a2n[7] = "ﾌｧ";
        a2r[8] = "ma"; a2h[8] = "ま"; a2k[8] = "マ"; a2n[8] = "ﾏ";
        a2r[9] = "ya"; a2h[9] = "や"; a2k[9] = "ヤ"; a2n[9] = "ﾔ";
        a2r[10] = "ra"; a2h[10] = "ら"; a2k[10] = "ラ"; a2n[10] = "ﾗ";
        a2r[11] = "wa"; a2h[11] = "わ"; a2k[11] = "ワ"; a2n[11] = "ﾜ";
        a2r[12] = "ga"; a2h[12] = "が"; a2k[12] = "ガ"; a2n[12] = "ｶﾞ";
        a2r[13] = "za"; a2h[13] = "ざ"; a2k[13] = "ザ"; a2n[13] = "ｻﾞ";
        a2r[14] = "ja"; a2h[14] = "じゃ"; a2k[14] = "ジャ"; a2n[14] = "ｼﾞｬ";
        a2r[15] = "da"; a2h[15] = "だ"; a2k[15] = "ダ"; a2n[15] = "ﾀﾞ";
        a2r[16] = "ba"; a2h[16] = "ば"; a2k[16] = "バ"; a2n[16] = "ﾊﾞ";
        a2r[17] = "pa"; a2h[17] = "ぱ"; a2k[17] = "パ"; a2n[17] = "ﾊﾟ";
        a2r[18] = "va"; a2h[18] = "う゛ぁ"; a2k[18] = "ヴァ"; a2n[18] = "ｳﾞｧ";

        a1r = new String[1];
        a1h = new String[1];
        a1k = new String[1];
        a1n = new String[1];
        a1r[0] = "a"; a1h[0] = "あ"; a1k[0] = "ア"; a1n[0] = "ｱ";

        i3r = new String[22];
        i3h = new String[22];
        i3k = new String[22];
        i3n = new String[22];
        i3r[0] = "kyi"; i3h[0] = "きぃ"; i3k[0] = "キィ"; i3n[0] = "ｷｨ";
        i3r[1] = "syi"; i3h[1] = "しぃ"; i3k[1] = "シィ"; i3n[1] = "ｼｨ";
        i3r[2] = "shi"; i3h[2] = "し"; i3k[2] = "シ"; i3n[2] = "ｼ";
        i3r[3] = "chi"; i3h[3] = "ち"; i3k[3] = "チ"; i3n[3] = "ﾁ";
        i3r[4] = "tyi"; i3h[4] = "ちぃ"; i3k[4] = "チィ"; i3n[4] = "ﾁｨ";
        i3r[5] = "cyi"; i3h[5] = "ちぃ"; i3k[5] = "チィ"; i3n[5] = "ﾁｨ";
        i3r[6] = "tsi"; i3h[6] = "つぃ"; i3k[6] = "ツィ"; i3n[6] = "ﾂｨ";
        i3r[7] = "thi"; i3h[7] = "てぃ"; i3k[7] = "ティ"; i3n[7] = "ﾃｨ";
        i3r[8] = "nyi"; i3h[8] = "にぃ"; i3k[8] = "ニィ"; i3n[8] = "ﾆｨ";
        i3r[9] = "hyi"; i3h[9] = "ひぃ"; i3k[9] = "ヒィ"; i3n[9] = "ﾋｨ";
        i3r[10] = "fyi"; i3h[10] = "ふぃ"; i3k[10] = "フィ"; i3n[10] = "ﾌｨ";
        i3r[11] = "myi"; i3h[11] = "みぃ"; i3k[11] = "ミィ"; i3n[11] = "ﾐｨ";
        i3r[12] = "lyi"; i3h[12] = "ぃ"; i3k[12] = "ィ"; i3n[12] = "ｨ";
        i3r[13] = "xyi"; i3h[13] = "ぃ"; i3k[13] = "ィ"; i3n[13] = "ｨ";
        i3r[14] = "ryi"; i3h[14] = "りぃ"; i3k[14] = "リィ"; i3n[14] = "ﾘｨ";
        i3r[15] = "gyi"; i3h[15] = "ぎぃ"; i3k[15] = "ギィ"; i3n[15] = "ｷﾞｨ";
        i3r[16] = "jyi"; i3h[16] = "じぃ"; i3k[16] = "ジィ"; i3n[16] = "ｼﾞｨ";
        i3r[17] = "zyi"; i3h[17] = "じぃ"; i3k[17] = "ジィ"; i3n[17] = "ｼﾞｨ";
        i3r[18] = "dyi"; i3h[18] = "ぢぃ"; i3k[18] = "ヂィ"; i3n[18] = "ﾁﾞｨ";
        i3r[19] = "dhi"; i3h[19] = "でぃ"; i3k[19] = "ディ"; i3n[19] = "ﾃﾞｨ";
        i3r[20] = "byi"; i3h[20] = "びぃ"; i3k[20] = "ビィ"; i3n[20] = "ﾋﾞｨ";
        i3r[21] = "pyi"; i3h[21] = "ぴぃ"; i3k[21] = "ピィ"; i3n[21] = "ﾋﾟｨ";

        i2r = new String[19];
        i2h = new String[19];
        i2k = new String[19];
        i2n = new String[19];
        i2r[0] = "li"; i2h[0] = "ぃ"; i2k[0] = "ィ"; i2n[0] = "ｨ";
        i2r[1] = "xi"; i2h[1] = "ぃ"; i2k[1] = "ィ"; i2n[1] = "ｨ";
        i2r[2] = "ki"; i2h[2] = "き"; i2k[2] = "キ"; i2n[2] = "ｷ";
        i2r[3] = "si"; i2h[3] = "し"; i2k[3] = "シ"; i2n[3] = "ｼ";
        i2r[4] = "ti"; i2h[4] = "ち"; i2k[4] = "チ"; i2n[4] = "ﾁ";
        i2r[5] = "ni"; i2h[5] = "に"; i2k[5] = "ニ"; i2n[5] = "ﾆ";
        i2r[6] = "hi"; i2h[6] = "ひ"; i2k[6] = "ヒ"; i2n[6] = "ﾋ";
        i2r[7] = "fi"; i2h[7] = "ふぃ"; i2k[7] = "フィ"; i2n[7] = "ﾌｨ";
        i2r[8] = "mi"; i2h[8] = "み"; i2k[8] = "ミ"; i2n[8] = "ﾐ";
        i2r[9] = "yi"; i2h[9] = "い"; i2k[9] = "イ"; i2n[9] = "ｲ";
        i2r[10] = "ri"; i2h[10] = "り"; i2k[10] = "リ"; i2n[10] = "ﾘ";
        i2r[11] = "wi"; i2h[11] = "うぃ"; i2k[11] = "ウィ"; i2n[11] = "ｳｨ";
        i2r[12] = "gi"; i2h[12] = "ぎ"; i2k[12] = "ギ"; i2n[12] = "ｷﾞ";
        i2r[13] = "zi"; i2h[13] = "じ"; i2k[13] = "ジ"; i2n[13] = "ｼﾞ";
        i2r[14] = "ji"; i2h[14] = "じ"; i2k[14] = "ジ"; i2n[14] = "ｼﾞ";
        i2r[15] = "di"; i2h[15] = "ぢ"; i2k[15] = "ヂ"; i2n[15] = "ﾁﾞ";
        i2r[16] = "bi"; i2h[16] = "び"; i2k[16] = "ビ"; i2n[16] = "ﾋﾞ";
        i2r[17] = "pi"; i2h[17] = "ぴ"; i2k[17] = "ピ"; i2n[17] = "ﾋﾟ";
        i2r[18] = "vi"; i2h[18] = "う゛ぃ"; i2k[18] = "ヴィ"; i2n[18] = "ｳﾞｨ";

        i1r = new String[1];
        i1h = new String[1];
        i1k = new String[1];
        i1n = new String[1];
        i1r[0] = "i"; i1h[0] = "い"; i1k[0] = "イ"; i1n[0] = "ｲ";

        u4r = new String[2];
        u4h = new String[2];
        u4k = new String[2];
        u4n = new String[2];
        u4r[0] = "ltsu"; u4h[0] = "っ"; u4k[0] = "ッ"; u4n[0] = "ｯ";
        u4r[1] = "xtsu"; u4h[1] = "っ"; u4k[1] = "ッ"; u4n[1] = "ｯ";

        u3r = new String[26];
        u3h = new String[26];
        u3k = new String[26];
        u3n = new String[26];
        u3r[0] = "kyu"; u3h[0] = "きゅ"; u3k[0] = "キュ"; u3n[0] = "ｷｭ";
        u3r[1] = "syu"; u3h[1] = "しゅ"; u3k[1] = "シュ"; u3n[1] = "ｼｭ";
        u3r[2] = "shu"; u3h[2] = "しゅ"; u3k[2] = "シュ"; u3n[2] = "ｼｭ";
        u3r[3] = "tsu"; u3h[3] = "つ"; u3k[3] = "ツ"; u3n[3] = "ﾂ";
        u3r[4] = "ltu"; u3h[4] = "っ"; u3k[4] = "ッ"; u3n[4] = "ｯ";
        u3r[5] = "xtu"; u3h[5] = "っ"; u3k[5] = "ッ"; u3n[5] = "ｯ";
        u3r[6] = "tyu"; u3h[6] = "ちゅ"; u3k[6] = "チュ"; u3n[6] = "ﾁｭ";
        u3r[7] = "cyu"; u3h[7] = "ちゅ"; u3k[7] = "チュ"; u3n[7] = "ﾁｭ";
        u3r[8] = "chu"; u3h[8] = "ちゅ"; u3k[8] = "チュ"; u3n[8] = "ﾁｭ";
        u3r[9] = "thu"; u3h[9] = "てゅ"; u3k[9] = "テュ"; u3n[9] = "ﾃｭ";
        u3r[10] = "twu"; u3h[10] = "とぅ"; u3k[10] = "トゥ"; u3n[10] = "ﾄｩ";
        u3r[11] = "nyu"; u3h[11] = "にゅ"; u3k[11] = "ニュ"; u3n[11] = "ﾆｭ";
        u3r[12] = "hyu"; u3h[12] = "ひゅ"; u3k[12] = "ヒュ"; u3n[12] = "ﾋｭ";
        u3r[13] = "fyu"; u3h[13] = "ふゅ"; u3k[13] = "フュ"; u3n[13] = "ﾌｭ";
        u3r[14] = "myu"; u3h[14] = "みゅ"; u3k[14] = "ミュ"; u3n[14] = "ﾐｭ";
        u3r[15] = "lyu"; u3h[15] = "ゅ"; u3k[15] = "ュ"; u3n[15] = "ｭ";
        u3r[16] = "xyu"; u3h[16] = "ゅ"; u3k[16] = "ュ"; u3n[16] = "ｭ";
        u3r[17] = "ryu"; u3h[17] = "りゅ"; u3k[17] = "リュ"; u3n[17] = "ﾘｭ";
        u3r[18] = "gyu"; u3h[18] = "ぎゅ"; u3k[18] = "ギュ"; u3n[18] = "ｷﾞｭ";
        u3r[19] = "jyu"; u3h[19] = "じゅ"; u3k[19] = "ジュ"; u3n[19] = "ｼﾞｭ";
        u3r[20] = "zyu"; u3h[20] = "じゅ"; u3k[20] = "ジュ"; u3n[20] = "ｼﾞｭ";
        u3r[21] = "dyu"; u3h[21] = "ぢゅ"; u3k[21] = "ヂュ"; u3n[21] = "ﾁﾞｭ";
        u3r[22] = "dhu"; u3h[22] = "でゅ"; u3k[22] = "デュ"; u3n[22] = "ﾃﾞｭ";
        u3r[23] = "dwu"; u3h[23] = "どぅ"; u3k[23] = "ドゥ"; u3n[23] = "ﾄﾞｩ";
        u3r[24] = "byu"; u3h[24] = "びゅ"; u3k[24] = "ビュ"; u3n[24] = "ﾋﾞｭ";
        u3r[25] = "pyu"; u3h[25] = "ぴゅ"; u3k[25] = "ピュ"; u3n[25] = "ﾋﾟｭ";

        u2r = new String[19];
        u2h = new String[19];
        u2k = new String[19];
        u2n = new String[19];
        u2r[0] = "lu"; u2h[0] = "ぅ"; u2k[0] = "ゥ"; u2n[0] = "ｩ";
        u2r[1] = "xu"; u2h[1] = "ぅ"; u2k[1] = "ゥ"; u2n[1] = "ｩ";
        u2r[2] = "ku"; u2h[2] = "く"; u2k[2] = "ク"; u2n[2] = "ｸ";
        u2r[3] = "su"; u2h[3] = "す"; u2k[3] = "ス"; u2n[3] = "ｽ";
        u2r[4] = "tu"; u2h[4] = "つ"; u2k[4] = "ツ"; u2n[4] = "ﾂ";
        u2r[5] = "nu"; u2h[5] = "ぬ"; u2k[5] = "ヌ"; u2n[5] = "ﾇ";
        u2r[6] = "hu"; u2h[6] = "ふ"; u2k[6] = "フ"; u2n[6] = "ﾌ";
        u2r[7] = "fu"; u2h[7] = "ふ"; u2k[7] = "フ"; u2n[7] = "ﾌ";
        u2r[8] = "mu"; u2h[8] = "む"; u2k[8] = "ム"; u2n[8] = "ﾑ";
        u2r[9] = "yu"; u2h[9] = "ゆ"; u2k[9] = "ユ"; u2n[9] = "ﾕ";
        u2r[10] = "ru"; u2h[10] = "る"; u2k[10] = "ル"; u2n[10] = "ﾙ";
        u2r[11] = "wu"; u2h[11] = "う"; u2k[11] = "ウ"; u2n[11] = "ｳ";
        u2r[12] = "gu"; u2h[12] = "ぐ"; u2k[12] = "グ"; u2n[12] = "ｸﾞ";
        u2r[13] = "zu"; u2h[13] = "ず"; u2k[13] = "ズ"; u2n[13] = "ｽﾞ";
        u2r[14] = "ju"; u2h[14] = "じゅ"; u2k[14] = "ジュ"; u2n[14] = "ｼﾞｭ";
        u2r[15] = "du"; u2h[15] = "づ"; u2k[15] = "ヅ"; u2n[15] = "ﾂﾞ";
        u2r[16] = "bu"; u2h[16] = "ぶ"; u2k[16] = "ブ"; u2n[16] = "ﾌﾞ";
        u2r[17] = "pu"; u2h[17] = "ぷ"; u2k[17] = "プ"; u2n[17] = "ﾌﾟ";
        u2r[18] = "vu"; u2h[18] = "う゛"; u2k[18] = "ヴ"; u2n[18] = "ｳﾞ";

        u1r = new String[1];
        u1h = new String[1];
        u1k = new String[1];
        u1n = new String[1];
        u1r[0] = "u"; u1h[0] = "う"; u1k[0] = "ウ"; u1n[0] = "ｳ";

        e3r = new String[24];
        e3h = new String[24];
        e3k = new String[24];
        e3n = new String[24];
        e3r[0] = "kye"; e3h[0] = "きぇ"; e3k[0] = "キェ"; e3n[0] = "ｷｪ";
        e3r[1] = "sye"; e3h[1] = "しぇ"; e3k[1] = "シェ"; e3n[1] = "ｼｪ";
        e3r[2] = "she"; e3h[2] = "しぇ"; e3k[2] = "シェ"; e3n[2] = "ｼｪ";
        e3r[3] = "tye"; e3h[3] = "ちぇ"; e3k[3] = "チェ"; e3n[3] = "ﾁｪ";
        e3r[4] = "cye"; e3h[4] = "ちぇ"; e3k[4] = "チェ"; e3n[4] = "ﾁｪ";
        e3r[5] = "che"; e3h[5] = "ちぇ"; e3k[5] = "チェ"; e3n[5] = "ﾁｪ";
        e3r[6] = "tse"; e3h[6] = "つぇ"; e3k[6] = "ツェ"; e3n[6] = "ﾂｪ";
        e3r[7] = "the"; e3h[7] = "てぇ"; e3k[7] = "テェ"; e3n[7] = "ﾃｪ";
        e3r[8] = "nye"; e3h[8] = "にぇ"; e3k[8] = "ニェ"; e3n[8] = "ﾆｪ";
        e3r[9] = "hye"; e3h[9] = "ひぇ"; e3k[9] = "ヒェ"; e3n[9] = "ﾋｪ";
        e3r[10] = "fye"; e3h[10] = "ふぇ"; e3k[10] = "フェ"; e3n[10] = "ﾌｪ";
        e3r[11] = "mye"; e3h[11] = "みぇ"; e3k[11] = "ミェ"; e3n[11] = "ﾐｪ";
        e3r[12] = "lye"; e3h[12] = "ぇ"; e3k[12] = "ェ"; e3n[12] = "ｪ";
        e3r[13] = "xye"; e3h[13] = "ぇ"; e3k[13] = "ェ"; e3n[13] = "ｪ";
        e3r[14] = "rye"; e3h[14] = "りぇ"; e3k[14] = "リェ"; e3n[14] = "ﾘｪ";
        e3r[15] = "gye"; e3h[15] = "ぎぇ"; e3k[15] = "ギェ"; e3n[15] = "ｷﾞｪ";
        e3r[16] = "jye"; e3h[16] = "じぇ"; e3k[16] = "ジェ"; e3n[16] = "ｼﾞｪ";
        e3r[17] = "zye"; e3h[17] = "じぇ"; e3k[17] = "ジェ"; e3n[17] = "ｼﾞｪ";
        e3r[18] = "dye"; e3h[18] = "ぢぇ"; e3k[18] = "ヂェ"; e3n[18] = "ﾁﾞｪ";
        e3r[19] = "dhe"; e3h[19] = "でぇ"; e3k[19] = "デェ"; e3n[19] = "ﾃﾞｪ";
        e3r[20] = "bye"; e3h[20] = "びぇ"; e3k[20] = "ビェ"; e3n[20] = "ﾋﾞｪ";
        e3r[21] = "pye"; e3h[21] = "ぴぇ"; e3k[21] = "ピェ"; e3n[21] = "ﾋﾟｪ";
        e3r[22] = "lke"; e3h[22] = "ヶ"; e3k[22] = "ヶ"; e3n[22] = "";
        e3r[23] = "xke"; e3h[23] = "ヶ"; e3k[23] = "ヶ"; e3n[23] = "";

        e2r = new String[19];
        e2h = new String[19];
        e2k = new String[19];
        e2n = new String[19];
        e2r[0] = "le"; e2h[0] = "ぇ"; e2k[0] = "ェ"; e2n[0] = "ｪ";
        e2r[1] = "xe"; e2h[1] = "ぇ"; e2k[1] = "ェ"; e2n[1] = "ｪ";
        e2r[2] = "ke"; e2h[2] = "け"; e2k[2] = "ケ"; e2n[2] = "ｹ";
        e2r[3] = "se"; e2h[3] = "せ"; e2k[3] = "セ"; e2n[3] = "ｾ";
        e2r[4] = "te"; e2h[4] = "て"; e2k[4] = "テ"; e2n[4] = "ﾃ";
        e2r[5] = "ne"; e2h[5] = "ね"; e2k[5] = "ネ"; e2n[5] = "ﾈ";
        e2r[6] = "he"; e2h[6] = "へ"; e2k[6] = "ヘ"; e2n[6] = "ﾍ";
        e2r[7] = "fe"; e2h[7] = "ふぇ"; e2k[7] = "フェ"; e2n[7] = "ﾌｪ";
        e2r[8] = "me"; e2h[8] = "め"; e2k[8] = "メ"; e2n[8] = "ﾒ";
        e2r[9] = "ye"; e2h[9] = "いぇ"; e2k[9] = "イェ"; e2n[9] = "ｲｪ";
        e2r[10] = "re"; e2h[10] = "れ"; e2k[10] = "レ"; e2n[10] = "ﾚ";
        e2r[11] = "we"; e2h[11] = "うぇ"; e2k[11] = "ウェ"; e2n[11] = "ｳｪ";
        e2r[12] = "ge"; e2h[12] = "げ"; e2k[12] = "ゲ"; e2n[12] = "ｹﾞ";
        e2r[13] = "ze"; e2h[13] = "ぜ"; e2k[13] = "ゼ"; e2n[13] = "ｾﾞ";
        e2r[14] = "je"; e2h[14] = "じぇ"; e2k[14] = "ジェ"; e2n[14] = "ｼﾞｪ";
        e2r[15] = "de"; e2h[15] = "で"; e2k[15] = "デ"; e2n[15] = "ﾃﾞ";
        e2r[16] = "be"; e2h[16] = "べ"; e2k[16] = "ベ"; e2n[16] = "ﾍﾞ";
        e2r[17] = "pe"; e2h[17] = "ぺ"; e2k[17] = "ペ"; e2n[17] = "ﾍﾟ";
        e2r[18] = "ve"; e2h[18] = "う゛ぇ"; e2k[18] = "ヴェ"; e2n[18] = "ｳﾞｪ";

        e1r = new String[1];
        e1h = new String[1];
        e1k = new String[1];
        e1n = new String[1];
        e1r[0] = "e"; e1h[0] = "え"; e1k[0] = "エ"; e1n[0] = "ｴ";

        o3r = new String[22];
        o3h = new String[22];
        o3k = new String[22];
        o3n = new String[22];
        o3r[0] = "kyo"; o3h[0] = "きょ"; o3k[0] = "キョ"; o3n[0] = "ｷｮ";
        o3r[1] = "syo"; o3h[1] = "しょ"; o3k[1] = "ショ"; o3n[1] = "ｼｮ";
        o3r[2] = "sho"; o3h[2] = "しょ"; o3k[2] = "ショ"; o3n[2] = "ｼｮ";
        o3r[3] = "tyo"; o3h[3] = "ちょ"; o3k[3] = "チョ"; o3n[3] = "ﾁｮ";
        o3r[4] = "cyo"; o3h[4] = "ちょ"; o3k[4] = "チョ"; o3n[4] = "ﾁｮ";
        o3r[5] = "cho"; o3h[5] = "ちょ"; o3k[5] = "チョ"; o3n[5] = "ﾁｮ";
        o3r[6] = "tso"; o3h[6] = "つぉ"; o3k[6] = "ツォ"; o3n[6] = "ﾂｫ";
        o3r[7] = "tho"; o3h[7] = "てょ"; o3k[7] = "テョ"; o3n[7] = "ﾃｮ";
        o3r[8] = "nyo"; o3h[8] = "にょ"; o3k[8] = "ニョ"; o3n[8] = "ﾆｮ";
        o3r[9] = "hyo"; o3h[9] = "ひょ"; o3k[9] = "ヒョ"; o3n[9] = "ﾋｮ";
        o3r[10] = "fyo"; o3h[10] = "ふょ"; o3k[10] = "フョ"; o3n[10] = "ﾌｮ";
        o3r[11] = "myo"; o3h[11] = "みょ"; o3k[11] = "ミョ"; o3n[11] = "ﾐｮ";
        o3r[12] = "lyo"; o3h[12] = "ょ"; o3k[12] = "ョ"; o3n[12] = "ｮ";
        o3r[13] = "xyo"; o3h[13] = "ょ"; o3k[13] = "ョ"; o3n[13] = "ｮ";
        o3r[14] = "ryo"; o3h[14] = "りょ"; o3k[14] = "リョ"; o3n[14] = "ﾘｮ";
        o3r[15] = "gyo"; o3h[15] = "ぎょ"; o3k[15] = "ギョ"; o3n[15] = "ｷﾞｮ";
        o3r[16] = "jyo"; o3h[16] = "じょ"; o3k[16] = "ジョ"; o3n[16] = "ｼﾞｮ";
        o3r[17] = "zyo"; o3h[17] = "じょ"; o3k[17] = "ジョ"; o3n[17] = "ｼﾞｮ";
        o3r[18] = "dyo"; o3h[18] = "ぢょ"; o3k[18] = "ヂョ"; o3n[18] = "ﾁﾞｮ";
        o3r[19] = "dho"; o3h[19] = "でょ"; o3k[19] = "デョ"; o3n[19] = "ﾃﾞｮ";
        o3r[20] = "byo"; o3h[20] = "びょ"; o3k[20] = "ビョ"; o3n[20] = "ﾋﾞｮ";
        o3r[21] = "pyo"; o3h[21] = "ぴょ"; o3k[21] = "ピョ"; o3n[21] = "ﾋﾟｮ";

        o2r = new String[19];
        o2h = new String[19];
        o2k = new String[19];
        o2n = new String[19];
        o2r[0] = "lo"; o2h[0] = "ぉ"; o2k[0] = "ォ"; o2n[0] = "ｫ";
        o2r[1] = "xo"; o2h[1] = "ぉ"; o2k[1] = "ォ"; o2n[1] = "ｫ";
        o2r[2] = "ko"; o2h[2] = "こ"; o2k[2] = "コ"; o2n[2] = "ｺ";
        o2r[3] = "so"; o2h[3] = "そ"; o2k[3] = "ソ"; o2n[3] = "ｿ";
        o2r[4] = "to"; o2h[4] = "と"; o2k[4] = "ト"; o2n[4] = "ﾄ";
        o2r[5] = "no"; o2h[5] = "の"; o2k[5] = "ノ"; o2n[5] = "ﾉ";
        o2r[6] = "ho"; o2h[6] = "ほ"; o2k[6] = "ホ"; o2n[6] = "ﾎ";
        o2r[7] = "fo"; o2h[7] = "ふぉ"; o2k[7] = "フォ"; o2n[7] = "ﾌｫ";
        o2r[8] = "mo"; o2h[8] = "も"; o2k[8] = "モ"; o2n[8] = "ﾓ";
        o2r[9] = "yo"; o2h[9] = "よ"; o2k[9] = "ヨ"; o2n[9] = "ﾖ";
        o2r[10] = "ro"; o2h[10] = "ろ"; o2k[10] = "ロ"; o2n[10] = "ﾛ";
        o2r[11] = "wo"; o2h[11] = "を"; o2k[11] = "ヲ"; o2n[11] = "ｦ";
        o2r[12] = "go"; o2h[12] = "ご"; o2k[12] = "ゴ"; o2n[12] = "ｺﾞ";
        o2r[13] = "zo"; o2h[13] = "ぞ"; o2k[13] = "ゾ"; o2n[13] = "ｿﾞ";
        o2r[14] = "jo"; o2h[14] = "じょ"; o2k[14] = "ジョ"; o2n[14] = "ｼﾞｮ";
        o2r[15] = "do"; o2h[15] = "ど"; o2k[15] = "ド"; o2n[15] = "ﾄﾞ";
        o2r[16] = "bo"; o2h[16] = "ぼ"; o2k[16] = "ボ"; o2n[16] = "ﾎﾞ";
        o2r[17] = "po"; o2h[17] = "ぽ"; o2k[17] = "ポ"; o2n[17] = "ﾎﾟ";
        o2r[18] = "vo"; o2h[18] = "う゛ぉ"; o2k[18] = "ヴォ"; o2n[18] = "ｳﾞｫ";

        o1r = new String[1];
        o1h = new String[1];
        o1k = new String[1];
        o1n = new String[1];
        o1r[0] = "o"; o1h[0] = "お"; o1k[0] = "オ"; o1n[0] = "ｵ";
    }

    public String getMoji(int mode, String roma)
    {
        int i, len = roma.length();
        String roma2 = roma.toLowerCase();
        String result;
        if (0 == roma2.substring(len - 1).compareTo("a")) {
            if (len >= 3) {
                for (i = 0; i < a3r.length; i++) {
                    if (0 == a3r[i].compareTo(roma2.substring(len - 3))) {
                        switch (mode) {
                            case 0 : result = a3h[i]; break;
                            case 1 : result = a3k[i]; break;
                            case 2 : result = a3n[i]; break;
                            default : result = "";
                        }
                        if (0 == result.compareTo("")) return roma;
                        else if (len > 3) return roma.substring(0, len - 3) + result;
                        else return result;
                    }
                }
            }
            if (len >= 2) {
                for (i = 0; i < a2r.length; i++) {
                    if (0 == a2r[i].compareTo(roma2.substring(len - 2))) {
                        switch (mode) {
                            case 0 : result = a2h[i]; break;
                            case 1 : result = a2k[i]; break;
                            case 2 : result = a2n[i]; break;
                            default : result = "";
                        }
                        if (0 == result.compareTo("")) return roma;
                        else if (len > 2) return roma.substring(0, len - 2) + result;
                        else return result;
                    }
                }
            }
            if (len >= 1) {
                if (0 == a1r[0].compareTo(roma2.substring(len - 1))) {
                    switch (mode) {
                        case 0 : result = a1h[0]; break;
                        case 1 : result = a1k[0]; break;
                        case 2 : result = a1n[0]; break;
                        default : result = "";
                    }
                    if (0 == result.compareTo("")) return roma;
                    else if (len > 1) return roma.substring(0, len - 1) + result;
                    else return result;
                }
                return roma;
            }
        }
        if (0 == roma2.substring(len - 1).compareTo("i")) {
            if (len >= 3) {
                for (i = 0; i < i3r.length; i++) {
                    if (0 == i3r[i].compareTo(roma2.substring(len - 3))) {
                        switch (mode) {
                            case 0 : result = i3h[i]; break;
                            case 1 : result = i3k[i]; break;
                            case 2 : result = i3n[i]; break;
                            default : result = "";
                        }
                        if (0 == result.compareTo("")) return roma;
                        else if (len > 3) return roma.substring(0, len - 3) + result;
                        else return result;
                    }
                }
            }
            if (len >= 2) {
                for (i = 0; i < i2r.length; i++) {
                    if (0 == i2r[i].compareTo(roma2.substring(len - 2))) {
                        switch (mode) {
                            case 0 : result = i2h[i]; break;
                            case 1 : result = i2k[i]; break;
                            case 2 : result = i2n[i]; break;
                            default : result = "";
                        }
                        if (0 == result.compareTo("")) return roma;
                        else if (len > 2) return roma.substring(0, len - 2) + result;
                        else return result;
                    }
                }
            }
            if (len >= 1) {
                if (0 == i1r[0].compareTo(roma2.substring(len - 1))) {
                    switch (mode) {
                        case 0 : result = i1h[0]; break;
                        case 1 : result = i1k[0]; break;
                        case 2 : result = i1n[0]; break;
                        default : result = "";
                    }
                    if (0 == result.compareTo("")) return roma;
                    else if (len > 1) return roma.substring(0, len - 1) + result;
                    else return result;
                }
                return roma;
            }
        }
        if (0 == roma2.substring(len - 1).compareTo("u")) {
            if (len >= 4) {
                for (i = 0; i < u4r.length; i++) {
                    if (0 == u4r[i].compareTo(roma2.substring(len - 4))) {
                        switch (mode) {
                            case 0 : result = u4h[i]; break;
                            case 1 : result = u4k[i]; break;
                            case 2 : result = u4n[i]; break;
                            default : result = "";
                        }
                        if (0 == result.compareTo("")) return roma;
                        else if (len > 4) return roma.substring(0, len - 4) + result;
                        else return result;
                    }
                }
            }
            if (len >= 3) {
                for (i = 0; i < u3r.length; i++) {
                    if (0 == u3r[i].compareTo(roma2.substring(len - 3))) {
                        switch (mode) {
                            case 0 : result = u3h[i]; break;
                            case 1 : result = u3k[i]; break;
                            case 2 : result = u3n[i]; break;
                            default : result = "";
                        }
                        if (0 == result.compareTo("")) return roma;
                        else if (len > 3) return roma.substring(0, len - 3) + result;
                        else return result;
                    }
                }
            }
            if (len >= 2) {
                for (i = 0; i < u2r.length; i++) {
                    if (0 == u2r[i].compareTo(roma2.substring(len - 2))) {
                        switch (mode) {
                            case 0 : result = u2h[i]; break;
                            case 1 : result = u2k[i]; break;
                            case 2 : result = u2n[i]; break;
                            default : result = "";
                        }
                        if (0 == result.compareTo("")) return roma;
                        else if (len > 2) return roma.substring(0, len - 2) + result;
                        else return result;
                    }
                }
            }
            if (len >= 1) {
                if (0 == u1r[0].compareTo(roma2.substring(len - 1))) {
                    switch (mode) {
                        case 0 : result = u1h[0]; break;
                        case 1 : result = u1k[0]; break;
                        case 2 : result = u1n[0]; break;
                        default : result = "";
                    }
                    if (0 == result.compareTo("")) return roma;
                    else if (len > 1) return roma.substring(0, len - 1) + result;
                    else return result;
                }
                return roma;
            }
        }
        if (0 == roma2.substring(len - 1).compareTo("e")) {
            if (len >= 3) {
                for (i = 0; i < e3r.length; i++) {
                    if (0 == e3r[i].compareTo(roma2.substring(len - 3))) {
                        switch (mode) {
                            case 0 : result = e3h[i]; break;
                            case 1 : result = e3k[i]; break;
                            case 2 : result = e3n[i]; break;
                            default : result = "";
                        }
                        if (0 == result.compareTo("")) return roma;
                        else if (len > 3) return roma.substring(0, len - 3) + result;
                        else return result;
                    }
                }
            }
            if (len >= 2) {
                for (i = 0; i < e2r.length; i++) {
                    if (0 == e2r[i].compareTo(roma2.substring(len - 2))) {
                        switch (mode) {
                            case 0 : result = e2h[i]; break;
                            case 1 : result = e2k[i]; break;
                            case 2 : result = e2n[i]; break;
                            default : result = "";
                        }
                        if (0 == result.compareTo("")) return roma;
                        else if (len > 2) return roma.substring(0, len - 2) + result;
                        else return result;
                    }
                }
            }
            if (len >= 1) {
                if (0 == e1r[0].compareTo(roma2.substring(len - 1))) {
                    switch (mode) {
                        case 0 : result = e1h[0]; break;
                        case 1 : result = e1k[0]; break;
                        case 2 : result = e1n[0]; break;
                        default : result = "";
                    }
                    if (0 == result.compareTo("")) return roma;
                    else if (len > 1) return roma.substring(0, len - 1) + result;
                    else return result;
                }
                return roma;
            }
        }
        if (0 == roma2.substring(len - 1).compareTo("o")) {
            if (len >= 3) {
                for (i = 0; i < o3r.length; i++) {
                    if (0 == o3r[i].compareTo(roma2.substring(len - 3))) {
                        switch (mode) {
                            case 0 : result = o3h[i]; break;
                            case 1 : result = o3k[i]; break;
                            case 2 : result = o3n[i]; break;
                            default : result = "";
                        }
                        if (0 == result.compareTo("")) return roma;
                        else if (len > 3) return roma.substring(0, len - 3) + result;
                        else return result;
                    }
                }
            }
            if (len >= 2) {
                for (i = 0; i < o2r.length; i++) {
                    if (0 == o2r[i].compareTo(roma2.substring(len - 2))) {
                        switch (mode) {
                            case 0 : result = o2h[i]; break;
                            case 1 : result = o2k[i]; break;
                            case 2 : result = o2n[i]; break;
                            default : result = "";
                        }
                        if (0 == result.compareTo("")) return roma;
                        else if (len > 2) return roma.substring(0, len - 2) + result;
                        else return result;
                    }
                }
            }
            if (len >= 1) {
                if (0 == o1r[0].compareTo(roma2.substring(len - 1))) {
                    switch (mode) {
                        case 0 : result = o1h[0]; break;
                        case 1 : result = o1k[0]; break;
                        case 2 : result = o1n[0]; break;
                        default : result = "";
                    }
                    if (0 == result.compareTo("")) return roma;
                    else if (len > 1) return roma.substring(0, len - 1) + result;
                    else return result;
                }
                return roma;
            }
        }
        return roma;
    }
}
